/************************************************
 *		The Master Class		*
 *----------------------------------------------*
 * This class will run the state inside the	*
 * task with the highest priority.  The tasks	*
 * will be inside a list of processes.  Ideally *
 * each process would get to run its highest	*
 * priority state at the same time.  However,	*
 * we can't do this with out multiple computers *
 ************************************************/

#ifndef ___MASTERH___
#define ___MASTERH___

#include <string>
#include <list>
#include <time.h>	// clock() & CLOCKS_PER_SEC

using namespace std;

class CProcess;		// Forward declare because CProcess includes us

class CMaster
{
	public:
		CMaster();
		~CMaster();

		void addproc(CProcess *aProc);
		void print_proc();	// For debuging only
		void stop() { running = false; }
		void start();
		float gettime() { return ((float)clock())/CLOCKS_PER_SEC; }

		void send_message(void *data, string rcpt_to) {}
	
	private:
		list<CProcess *> the_processes;
		typedef list<CProcess *>::const_iterator LI;

		bool running;

};

#endif
