#include <iostream.h>

#include "process.h"
#include "master.h"
#include "task.h"

CProcess::CProcess(CMaster *my_boss, string name)
		: name(name), my_boss(my_boss)
{
	my_boss->addproc(this);
}

CProcess::~CProcess()
{
	wipe_tasks(int_tasks);
	wipe_tasks(sample_tasks);
	wipe_tasks(cont_tasks);
}

CProcess::addtask(CTask *aTask, RunType type)
{
	switch(type)
	{
		case continuous:	
			cont_tasks.push_front(aTask);
			aTask->lastrun = my_boss->gettime();
			break;
	
		case interupt:
			int_tasks.push_front(aTask);
			aTask->lastrun = my_boss->gettime();
			break;

		case sample:
			LI i=sample_tasks.begin();
			if( sample_tasks.size() == 0 )
			{
				sample_tasks.push_front(aTask);
				aTask->lastrun = my_boss->gettime();
			}
			else
			{
				CTask *ltask = *i;
				while( ltask->priority > aTask->priority)
				{
					++i;
					ltask = *i;
					if(i==sample_tasks.end()) break;
				}
				sample_tasks.insert(i,aTask);
			}
			break;
	}
}

CProcess::print_tasks() 
{
	for(LI i=int_tasks.begin(); i != int_tasks.end(); ++i)
	{
		CTask *atask = *i;
		cout << '\t' << atask->name.c_str() << '\n';
	}
}

int CProcess::run_task()
{
	float time = my_boss->gettime();

	if( run_time_list(int_tasks,time) )
		return(0);
	
	if( run_time_list(sample_tasks,time) )
		return(0);

	for(LI i=cont_tasks.begin(); i != cont_tasks.end(); ++i)
	{
		CTask *atask = *i;
		atask->run();
	}
	return(0);
}

CProcess::exitprogram()
{
	my_boss->stop();
}

bool CProcess::run_time_list(TaskList alist, float time)
{
	for(LI i=alist.begin(); i != alist.end(); ++i)
	{
		CTask *atask = *i;
		float elapsed  = time - atask->lastrun;
		
		if( atask->int_time <= elapsed )
		{
			atask->run();
			atask->lastrun = my_boss->gettime();
			return(true);
		}
	}
	return(false);
}
void CProcess::wipe_tasks(TaskList alist)
{
	for(LI i=alist.begin(); i != alist.end(); ++i)
	{
		CTask *atask = *i;
		cout << atask->message.c_str();
		delete atask;
	}
	alist.clear();
}

void CProcess::send_message(void *data, string rcpt_to)
{
	my_boss->send_message(data,rcpt_to);
}

