#ifndef ___PROCESSH___
#define ___PROCESSH___

#include <string>
#include <list>
#include <map>

using namespace std;

class CMaster;		// forward declare, we don't need to know about it
class CTask;

enum RunType { continuous, sample, interupt };

typedef list<CTask *> TaskList;

class CProcess
{
	public:
		CProcess(CMaster *, string);
		~CProcess();

		addtask(CTask *, RunType type);
		print_tasks();			// For debugging
		int run_task();			// return 0 if good
		exitprogram();
		
		bool run_time_list(TaskList alist, float time);
		void wipe_tasks(TaskList alist);

		void send_message(void *data, string rcpt_to);

		const string name;

	private:
		CMaster *my_boss;

		map<void *, string> messages;

		TaskList int_tasks;		// Run on time no exceptions
		TaskList sample_tasks;		// Run close to time
		TaskList cont_tasks;		// Run when nothing else to run

		typedef list<CTask *>::iterator LI;

};

#endif
